//-----------------------------
// Funes de regressao linear
// Marco de 2007
//-----------------------------

#include <math.h>

double fatorCorrelacao(char *texto, char *cifra, int tamanhoTexto)
{
	// testa o grau de correlao entre texto claro e cifrado
	// quanto maior o grau de correlao, pior o algoritmo de cifragem
	// referncia: http://alea-estp.ine.pt/ingles/html/nocoes/html/cap6_3_1.html
	double mediax, mediay, difx, dify, somaxy, somaxx, somayy, r, rd;
	int i;

	mediax = mediay = 0;
	for(i = 0; i < tamanhoTexto; i++) {
		mediax += texto[i];
		mediay += cifra[i];
	}		
	mediax /= tamanhoTexto;
	mediay /= tamanhoTexto;
	
	somaxy = somaxx = somayy = 0;
	for(i = 0; i < tamanhoTexto; i++) {
		difx = (texto[i] - mediax);
		dify = (cifra[i] - mediay);
		somaxy += difx*dify;
		somaxx += difx*difx;
		somayy += dify*dify;
	}
	
	rd = sqrt(somaxx)*sqrt(somayy);
	if(rd != 0)
		r = somaxy / rd;
	else
		r = 0;
		
	return r;
}

